<template>
    <div>
        <custom-card>
            <auto-datatable
                ref="dt"
                model="InvestmentPlan"
                :headers="[
                    {label: '#', name: 'id'},
                    {label: $t('actions'), name: 'actions'},
                    {label: $t('code'), name: 'code'},
                    {label: $t('plan_name'), name: 'plan_name'},
                    {label: $t('current_balance'), name: 'current_balance', column: 'current_balance', sortable: false},
                    {label: $t('updated_at'), name: 'updated_at'},
                ]"
            >
                <template #default="{records}">
                    <tr
                        v-for="(record, i) in records"
                        :key="i"
                    >
                        <td>{{ i+1 }}</td>
                        <td>
                            <div class="flex justify-start space-x-1">
                                <edit-button
                                    @click="model = record"
                                />
                                <view-button
                                    @click="$router.push({name: 'admin.investment_plan.transaction', params: {code: record.code}})"
                                />
                            </div>
                        </td>
                        <td>{{ record.code }}</td>
                        <td>{{ record.plan_name }}</td>
                        <td>{{ $helper.fundFormat(record.current_balance) }}</td>
                        <td>{{ $helper.dateTimeFormat(record.updated_at) }}</td>
                    </tr>
                </template>
            </auto-datatable>
        </custom-card>
        <panel-modal
            v-if="model"
            :has-footer="false"
            @close="model = null"
        >
            <template #body>
                <model-form
                    :form-model="model"
                    @update="updateRow"
                />
            </template>
        </panel-modal>
    </div>
</template>
<script setup>
import CustomCard from "~/components/custom-card.vue";
import PanelModal from "~/components/panel-modal.vue";
import AutoDatatable from "~/components/auto-datatable.vue";
import {inject, ref} from "vue";
import EditButton from "~/components/button/edit-button.vue";
import ModelForm from './model-form.vue';
import ViewButton from "~/components/button/view-button.vue";

const $helper = inject('$helper');
const model = ref(null);
const dt = ref();
const updateRow = async () => {
    model.value = null;

    await dt.value.loadData();
};
</script>
